<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html" indent="yes" encoding="US-ASCII" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN" />

  <xsl:variable name="fileName" select="descendant::Variable[@name='badboy.saveItemFileName'] " />	
  <xsl:variable name="saveDateTime" select="descendant::Variable[@name='badboy.saveDateTime'] " />	

  <xsl:template match="/">
  <xsl:variable name="failureCount" select="/BadboyDocument/Script/summary/failed" />
	<xsl:variable name="totalPlayed" select="/BadboyDocument/Script/summary/played" />	
	<xsl:variable name="successCount" select="/BadboyDocument/Script/summary/succeeded" />	
	<xsl:variable name="successPercentage" select="$successCount div $totalPlayed" />	
  <xsl:variable name="allFailureCount" select="count(descendant::Response[summary/failed != '0'])"/>
  <xsl:variable name="warningsCount" select="count(descendant::ResponseError)"/>
  <xsl:variable name="assertionCount" select="count(descendant::AssertionFailure)"/>
  <xsl:variable name="screenShotCount" select="count(descendant::CaptureItem)"/>
	<html>
		<head>
		<META http-equiv="Content-Type" content="text/html; charset=US-ASCII"/>
		<title>Badboy Test Results</title>		
		<style type="text/css">
						body {
							font:normal 68% verdana,arial,helvetica;
							color:#000000;
						}
						table tr td, table tr th {
							font-size: 68%;
						}
						table.details tr th{
							font-weight: bold;
							text-align:left;
							background:#a6caf0;
							white-space: nowrap;
						}

						table.details tr td{
							background:#eeeee0;
							white-space: nowrap;
						}

						table.detailsCentered tr td{
              text-align: center;
						}

						h1 {
							margin: 0px 0px 5px; font: 165% verdana,arial,helvetica
						}
						h2 {
							margin-top: 1em; margin-bottom: 0.5em; font: bold 125% verdana,arial,helvetica
						}
						h3 {
							margin-bottom: 0.5em; font: bold 115% verdana,arial,helvetica
						}
						.Failure {
							font-weight:bold; color:red;
						}
            .Centered {
              text-align: center;
            }

            a:link.FailureLink {
              color: red;
            }
	          a:visited.FailureLink {
              color: red;
            }

            .responseLogDiv {
              display: none;
            }

            /* Put this inside a @media qualifier so Netscape 4 ignores it */
            @media screen { 
              /* Turn off list bullets */
              ul.mktree  li { list-style: none; } 
              /* Control how "spaced out" the tree is */
              ul.mktree, ul.mktree ul , ul.mktree li { margin-left:10px; }
              /* Provide space for our own "bullet" inside the LI */
              ul.mktree  li           .bullet { padding-left: 15px; }
              /* Show "bullets" in the links, depending on the class of the LI that the link's in */
              ul.mktree  li.liOpen    .bullet { cursor: pointer; background: url(<xsl:value-of select="$fileName"/>-images/minus.gif)  center left no-repeat; }
              ul.mktree  li.liClosed  .bullet { cursor: pointer; background: url(<xsl:value-of select="$fileName"/>-images/plus.gif)   center left no-repeat; }
              ul.mktree  li.liBullet  .bullet { cursor: default; background: url(<xsl:value-of select="$fileName"/>-images/step.gif) center left no-repeat; }
              /* Sublists are visible or not based on class of parent LI */
              ul.mktree  li.liOpen    ul { display: block; }
              ul.mktree  li.liClosed  ul { display: none; }
              /* Format menu items differently depending on what level of the tree they are in */
              ul.mktree  li { font-size: 10pt; }
              ul.mktree  li ul li { font-size: 10pt; }
              ul.mktree  li ul li ul li { font-size: 10pt; }
              ul.mktree  ul li ul li ul li li { font-size: 10pt; }
              }


            .stepDiv {
            /* background: url(<xsl:value-of select="$fileName"/>-images/plus.gif)   center left no-repeat; */
            }

            .stepImage {
              position: relative;  
              top: 5px;
            }

						table.scriptTree tr th{
              position: relative;
              left: 420px;
              top: 0px;
							background:#eeeee0;
							font-weight: bold;
							text-align:left;
							background:#a6caf0;
							white-space: nowrap;
						}

						table.scriptTree tr td{
              position: relative;
              left: 420px;
							background:#eeeee0;
							white-space: nowrap;
              }


              .scriptTreeHeaderCell {
                width: 40px;
                height: 20px;
                padding-top: 3px;
                padding-bottom: 3px;
                background:#eeeee0;
                font-weight: bold;
                font-size: 10px;
                text-align:center;
                background:#a6caf0;
                white-space: nowrap;
                margin-top: 0px;
                margin-bottom: 0px;
                margin-left: 2px;
                margin-right: 2px;
              }

             .scriptTreeTotal {
              position: relative;
              top: 1px;
              width: 40px;
              background-color:#eeeee0;
              text-align: center;
              margin-top: 0px;
              margin-bottom: 0px;
              margin-left: 2px;
              margin-right: 2px;
            }


      </style>
			<script language="javacript" type="text/javascript">
        var imagesPath='<xsl:value-of select="translate($fileName,'\','/')"/>-images';
      <![CDATA[
      function expandTreeStep(stepId) {
        var children = document.getElementById('treeStepChildren'+stepId);
        var stepImg   = document.getElementById('stepImage'+stepId);
        if(stepImg.hasChildren == 'false') {
          return;
        }


        if(children.style.display=='block') {
          children.style.display='none';
          stepImg.src=imagesPath + '/plus.gif';
        }
        else {
          children.style.display='block';
          stepImg.src=imagesPath + '/minus.gif';
        }
      }

			function showFailed( divID ) {			
        failedHTML = document.getElementById(divID).innerHTML;
          newWin = window.open("error.html",'newWin',"height=800,width=600,status=yes,scrollbars=yes,toolbar=yes,menubar=yes,location=no");
          newWin.document.write(unescape(failedHTML.replace(/&amp;amp;/g,"&amp;").replace(/&amp;gt;/g,"&gt;").replace(/&amp;lt;/g,"&lt;")));			  
          newWin.focus();	          
       }

      function showLogContent(logId) {
         var logHTML=document.getElementById('log-'+logId).innerHTML;
         var logWin = window.open("log.html",'logWin',"height=500,width=800,status=yes,scrollbars=yes,toolbar=yes,menubar=yes,location=no");
         logWin.document.write(unescape(logHTML.replace(/&amp;amp;/g,"&amp;").replace(/&amp;gt;/g,"&gt;").replace(/&amp;lt;/g,"&lt;")));			  
         logWin.focus();	          
      }
        ]]>
      </script>		
      </head>
			<body>
        <h1>Badboy Test Results</h1>
        Report created <xsl:value-of select="$saveDateTime"/>
				<hr size="1"/>				
				<h2>Overview</h2>
				<table width="95%" cellspacing="2" cellpadding="5" border="0" class="details detailsCentered">
					<tr valign="top">
						<th>Total Played</th>
						<th>Succeeded</th>
						<th>Failed</th>
						<th>JS Errors</th>
						<th>Assertions</th>
						<th>Average Time</th>
						<th>Max Time</th>
					</tr>
					<tr valign="top" class="">
						<td><xsl:value-of select="$totalPlayed"/></td>
						<td><xsl:value-of select="$successCount"/></td>						
						<td><xsl:value-of select="$failureCount"/></td>						
						<td><xsl:value-of select="$warningsCount"/></td>						
						<td><xsl:value-of select="$assertionCount"/></td>						
						<td><xsl:value-of select="/BadboyDocument/Script/summary/averageResponseTime"/></td>
						<td><xsl:value-of select="/BadboyDocument/Script/summary/maxResponseTime"/></td>
					</tr>
				</table>

        <hr align="left" width="95%" size="1"/>
        <h2>Script Summary</h2>
        <div style="width: 718px; ">
          <div style="text-align: right;">
            <span style="width: 328px;">
              <span class="scriptTreeHeaderCell">Total</span> 
              <span class="scriptTreeHeaderCell">Succ</span> 
              <span class="scriptTreeHeaderCell">Fail</span> 
              <span class="scriptTreeHeaderCell">JS</span> 
              <span class="scriptTreeHeaderCell">Asst</span> 
              <span class="scriptTreeHeaderCell">Avg</span> 
              <span class="scriptTreeHeaderCell">Max</span> 
            </span>
        </div>
        <xsl:for-each select="/BadboyDocument/Script/ChildItems/Step">
              <xsl:call-template name="Step"/>
        </xsl:for-each>        
      </div>
      <br/>

        <xsl:if test="$assertionCount != 0">
          <hr align="left" width="95%" size="1"/>
          <h2>Assertion Summary</h2>
          <table width="95%" cellspacing="2" cellpadding="5" border="0" class="details">
            <tr valign="top">
              <th width="10%">Id</th>
              <th width="15%">Name</th>
              <th width="40%" nowrap="nowrap">Rule</th>
              <th width="15%">Status (Success or Failed) </th>
              <th width="10%">Failures</th>
            </tr>
              <xsl:for-each select="//Assertion">
                <xsl:call-template name="AssertionLineItem"/>
              </xsl:for-each>					
          </table>
        </xsl:if>

        <xsl:if test="$failureCount != 0">
          <hr align="left" width="95%" size="1"/>
          <h2>Failures (<xsl:value-of select="$allFailureCount"/>)</h2>
          <table width="95%" cellspacing="2" cellpadding="5" border="0" class="details">
            <tr valign="top">
              <th width="15%">Response Id</th>
              <th width="15%">Source Id</th>
              <th width="50%" nowrap="nowrap">URL/Name</th>
              <th width="20%">Error Code</th>
            </tr>
            <xsl:for-each select="descendant::Response[summary/failed != '0']" >
                <xsl:call-template name="ResponseFailureLineItem"/>
            </xsl:for-each>					
          </table>
        </xsl:if>

        <xsl:if test="$warningsCount != 0">
				<hr align="left" width="95%" size="1"/>
        <h2>JavaScript Errors (<xsl:value-of select="$warningsCount"/>)</h2>
				<table width="95%" cellspacing="2" cellpadding="5" border="0" class="details">
					<tr valign="top">
						<th width="20%">Id</th>
						<th width="35%">Source Id</th>
						<th width="40%">Description</th>
					</tr>
						<xsl:for-each select="//ResponseError">
							<xsl:call-template name="ResponseErrorLineItem"/>
						</xsl:for-each>					
          </table>
        </xsl:if>

        <xsl:if test="$assertionCount != 0">
          <hr align="left" width="95%" size="1"/>
          <h2>Assertion Failure Details</h2>
          <table width="95%" cellspacing="2" cellpadding="5" border="0" class="details">
            <tr valign="top">
              <th width="10%">Assertion Id</th>
              <th width="15%">Name</th>
              <th width="40%" nowrap="nowrap">Rule</th>
              <th width="10%">ScreenShot</th>
            </tr>
              <xsl:for-each select="//AssertionFailure">
                <xsl:call-template name="AssertionFailureLineItem"/>
              </xsl:for-each>					
          </table>
        </xsl:if>

        <xsl:if test="$screenShotCount != 0">
          <hr align="left" width="95%" size="1"/>
          <h2>All Screen Shots</h2>
          <table width="50%" cellspacing="2" cellpadding="5" border="0" class="details">
            <tr valign="top">
              <th width="20%">Id</th>
              <th width="50%">Name</th>
              <th width="30%">Thumbnail</th>
            </tr>
            <xsl:for-each select="//CaptureItem">
                <xsl:call-template name="ScreenShotLineItem"/>
              </xsl:for-each>					
          </table>
        </xsl:if>
          
        
				<hr align="left" width="95%" size="1"/>
				<h2>All Requests</h2>
				<table width="95%" cellspacing="2" cellpadding="5" border="0" class="details">
					<tr valign="top">
            <th width="20%">Request Id/Label</th>
						<th width="40%" nowrap="nowrap">URL</th>
						<th width="10%">Status (Success or Failed) </th>
						<th width="15%">Avg Time</th>
						<th width="15%">Max Time</th>
					</tr>
						<xsl:for-each select="//Request">
							<xsl:call-template name="TestLineItem"/>
						</xsl:for-each>					
          </table>          
				<hr align="left" width="95%" size="1"/>				
			</body>
		</html>
    </xsl:template>

    <xsl:template name="Step">
      <xsl:param name="depth">0</xsl:param>
      <xsl:param name="display">block</xsl:param>
      <div style="width: 800px;" class="stepDiv" id="treeStepDiv{Id}">      
        <div style="width: 200px; background-image: url({$fileName}-images/dot.gif); background-repeat: repeat-x;"> <!-- dot leader div -->
        <span style="width: 350px; padding-left: {$depth * 20};">
          <img id="stepImage{Id}" onclick="expandTreeStep({Id});" class="stepImage">
              <xsl:choose>
                <xsl:when test='count(descendant::Step) != 0 and $depth = 0'> <!-- root node -->
                  <xsl:attribute name="src"><xsl:value-of select="concat($fileName,'-images/minus.gif')"/></xsl:attribute>
                  <xsl:attribute name="hasChildren">true</xsl:attribute>
                  <xsl:attribute name="style">cursor: pointer;</xsl:attribute>
                </xsl:when>
                <xsl:when test='count(descendant::Step) != 0'> <!-- All nodes with children except root -->
                  <xsl:attribute name="src"><xsl:value-of select="concat($fileName,'-images/plus.gif')"/></xsl:attribute>
                  <xsl:attribute name="hasChildren">true</xsl:attribute>
                  <xsl:attribute name="style">cursor: pointer;</xsl:attribute>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:attribute name="src"><xsl:value-of select="concat($fileName,'-images/step.gif')"/></xsl:attribute>
                  <xsl:attribute name="hasChildren">false</xsl:attribute>
                </xsl:otherwise>
              </xsl:choose>
          </img>&#160;<xsl:value-of select="Name"/>&#160;          
        </span>
      </div> <!-- end dot leader div -->
      <!--      <span style="width: 250px; border-bottom-style: dotted; border-bottom-width: 1px; margin: 5px;" >&#160;</span>        -->
      <div style="text-align: right;">
        <span style="width: 308px;">
          <span class="scriptTreeTotal"><xsl:value-of select="summary/played"/>&#160;</span> 
          <span class="scriptTreeTotal"><xsl:value-of select="summary/succeeded"/>&#160;</span> 
          <span class="scriptTreeTotal"><xsl:value-of select="summary/failed"/>&#160;</span> 
          <span class="scriptTreeTotal"><xsl:value-of select="summary/warnings"/>&#160;</span> 
          <span class="scriptTreeTotal"><xsl:value-of select="summary/assertions"/>&#160;</span> 
          <span class="scriptTreeTotal"><xsl:value-of select="summary/averageResponseTime"/>&#160;</span> 
          <span class="scriptTreeTotal"><xsl:value-of select="summary/maxResponseTime"/>&#160;</span> 
        </span>
      </div>
    </div>
    <span id="treeStepChildren{Id}" style="display: {$display};">
      <xsl:for-each select="ChildItems/Step">
        <xsl:call-template name="Step">
          <xsl:with-param name="depth" select="$depth + 1"/>
          <xsl:with-param name="display" select="'none'"/>
        </xsl:call-template>
      </xsl:for-each>        
    </span>
  </xsl:template>

    
  <xsl:template name="TestLineItem">
    <xsl:variable name="divID">responseDiv-<xsl:value-of select="Id"/></xsl:variable>
    <xsl:variable name="responseHTML" select="descendant::Response[summary/failed != 0]/Content"/>
    <xsl:variable name="responseLog" select="descendant::Response[summary/failed != 0]/LogSection"/>
    <xsl:variable name="responseId" select="descendant::Response[summary/failed != 0]/Id"/>
      <tr valign="top" class="">
        <td nowrap="nowrap"><xsl:value-of select="Id"/><xsl:if test="Label != ''">&#160;-&#160;<xsl:value-of select="./Label"/></xsl:if></td>
        <td><xsl:value-of select="./Protocol"/>://<xsl:value-of select="./Host"/>:<xsl:value-of select="./Port"/><xsl:value-of select="./Path"/></td>
        <td class="Centered">
        <xsl:choose>
          <xsl:when test="./summary/failed != '0'"> 
           <span style="color:red">Failed - Error&#160;
             <a class="FailureLink" href="javascript:showFailed('{$divID}');"><xsl:attribute name="title">Error <xsl:value-of select="descendant::Response[ErrorCode != '0']/ErrorCode"/></xsl:attribute>(view)</a></span><div id="{$divID}" style="display:none;">
                    <xsl:value-of  select="$responseHTML"/>
                  </div>
            <xsl:if test="$responseLog != ''">&#160;
              <a class="FailureLink" href="javascript:showLogContent({$responseId})">
                <xsl:attribute name="title"><xsl:value-of select="concat(substring($responseLog,0,80),'...')"/></xsl:attribute>
                (log)</a>
            </xsl:if>
          </xsl:when>
          <xsl:when test="./following-sibling::*[1][self::Assertion]/Passed = 'false'">
            <a class="FailureLink" href="javascript:showFailed('{$divID}');">
            <div id="{$divID}" style="display:none;">
              <xsl:value-of select="$responseHTML"/>
            </div>Failed Assertion</a>           
          </xsl:when>
          <xsl:otherwise><span style="color:green;">Success</span></xsl:otherwise>
        </xsl:choose>
      </td>
      <td class="Centered"><xsl:value-of select="./summary/averageResponseTime"/></td>				
      <td class="Centered"><xsl:value-of select="./summary/maxResponseTime"/></td>				
    </tr>		
	</xsl:template>

  <xsl:template name="AssertionLineItem">
      <tr valign="top" class="">
      <td nowrap="nowrap"><xsl:value-of select="Id"/></td>
      <td><xsl:value-of select="ItemName"/></td>
      <td>Page <xsl:value-of select="Type"/>&#160;<xsl:value-of select="Pattern"/></td>
      <td class="Centered"><xsl:choose>
            <xsl:when test="Passed='true'"><span style="color:green;"> Passed</span></xsl:when>
            <xsl:otherwise>
              <a style="color: red;"><xsl:attribute name="href">#assertionDetail<xsl:value-of select="Id"/></xsl:attribute><span style="color:red;"> Failed</span></a>
             </xsl:otherwise>
          </xsl:choose>
      </td>
      <td class="Centered"><xsl:value-of select="./summary/assertions"/></td>				
    </tr>		
	</xsl:template>

  <xsl:template name="AssertionFailureLineItem">
      <tr valign="top" class="">
        <xsl:attribute name="name">assertionDetail<xsl:value-of select="../../Id"/></xsl:attribute>
        <td><a><xsl:attribute name="name">assertionDetail<xsl:value-of select="../../Id"/></xsl:attribute><xsl:value-of select="../../Id"/></a></td>
      <td><xsl:value-of select="../../ItemName"/></td>
      <td>Page <xsl:value-of select="../../Type"/>&#160;<xsl:value-of select="../../Pattern"/></td>
      <td><xsl:for-each select="ChildItems/CaptureItem">
          <a target="assertionImage">
            <xsl:attribute name="href"><xsl:value-of select="$fileName"/>-images/badboy-<xsl:value-of select="Id"/>.png</xsl:attribute>
            <img height="60" width="60" border="0">
              <xsl:attribute name="src"><xsl:value-of select="$fileName"/>-images/badboy-<xsl:value-of select="Id"/>.png</xsl:attribute>
            </img>
          </a>
        </xsl:for-each>
      </td>				
    </tr>		
	</xsl:template>
  
  <xsl:template name="ResponseErrorLineItem">
      <tr valign="top" class="">
      <td><xsl:value-of select="Id"/></td>
      <td><xsl:value-of select="../../Id"/></td>
      <td><xsl:value-of select="description"/></td>
    </tr>		
	</xsl:template>

  <xsl:template name="ScreenShotLineItem">
      <tr valign="top" class="">
      <td><xsl:value-of select="Id"/></td>
      <td><xsl:value-of select="Name"/></td>
      <td>
        <a target="assertionImage">
          <xsl:attribute name="href"><xsl:value-of select="$fileName"/>-images/badboy-<xsl:value-of select="Id"/>.png</xsl:attribute>
          <img height="60" width="60" border="0">
            <xsl:attribute name="src"><xsl:value-of select="$fileName"/>-images/badboy-<xsl:value-of select="Id"/>.png</xsl:attribute>
          </img>
        </a>
      </td>				
    </tr>		
	</xsl:template>

  <xsl:template name="ResponseFailureLineItem">
    <xsl:variable name="responseId" select="Id"/>
      <tr valign="top" class="">
      <td><xsl:value-of select="Id"/></td>
      <td><xsl:value-of select="../../Id"/></td>
      <td><xsl:choose>
        <xsl:when test="../../../../Path"><xsl:value-of select="../../../../Path"/></xsl:when>
        <xsl:otherwise><xsl:value-of select="../../../../ItemName"/></xsl:otherwise>
      </xsl:choose>
      </td>
      <td><xsl:value-of select="ErrorCode"/><xsl:if test='string-length(LogSection) &gt; 0'>&#160;
          <a href="javascript:showLogContent({$responseId})"><xsl:attribute name="title"><xsl:value-of select="concat(substring(LogSection,0,80),'...')"/></xsl:attribute>(show log)</a></xsl:if>
        <div id="log-{$responseId}" class="responseLogDiv"><pre style="font-size: 11px;"><xsl:value-of select="LogSection"/></pre></div>
      </td>
    </tr>		
	</xsl:template>

</xsl:stylesheet>
