<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="text" indent="yes" encoding="US-ASCII" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN" />
  <xsl:variable name="fileName" select="translate(descendant::Variable[@name='badboy.saveItemRelFileName'],'\','/') " />	
  <xsl:variable name="saveDateTime" select="descendant::Variable[@name='badboy.saveDateTime'] " />	
  <xsl:template match="/">
  <xsl:variable name="failureCount" select="/BadboyDocument/Script/summary/failed" />
	<xsl:variable name="totalPlayed" select="/BadboyDocument/Script/summary/played" />	
	<xsl:variable name="successCount" select="/BadboyDocument/Script/summary/succeeded" />	
	<xsl:variable name="successPercentage" select="$successCount div $totalPlayed" />	
  <xsl:variable name="allFailureCount" select="count(descendant::Response[summary/failed != '0'])"/>
  <xsl:variable name="warningsCount" select="count(descendant::ResponseError)"/>
  <xsl:variable name="assertionCount" select="count(descendant::AssertionFailure)"/>
  <xsl:variable name="screenShotCount" select="count(descendant::CaptureItem)"/>
        <!-- If everything passed, show a "success"  -->
        <xsl:choose>
          <xsl:when test=' $totalPlayed = $successCount and $warningsCount = 0 and $assertionCount = 0 and $failureCount = 0'>
            Success
          </xsl:when>
          <xsl:when test=' $totalPlayed = $successCount and $warningsCount != 0 and $assertionCount = 0 and $failureCount = 0'>
            Passed with Warnings
          </xsl:when>
          <xsl:otherwise>
            Test Failed
          </xsl:otherwise>
        </xsl:choose>
  </xsl:template>
</xsl:stylesheet>
